#include "R.h"

///////////////////////////////////////////////////////////

class C_Camera{

	float y_r;
	float distance;

public:

	void Init( VECTOR Target );
	void CameraMove( VECTOR Pos, VECTOR Target, char KeyBuf[256] );

};

///////////////////////////////////////////////////////////////

void C_Camera::Init( VECTOR Target )
{
	sCam.Pos = VGet( 30.0f, 10.0f, -60.0f);
	SetupCamera_Perspective( 60.0*PHI_F/180.0f );
	SetCameraNearFar( 0.1f, 1000.0f );
	SetCameraPositionAndTarget_UpVecY( sCam.Pos, Target );
}

//////////////////////////////////////////////////////////////

void C_Camera::CameraMove( VECTOR CharaVec, VECTOR Target, char KeyBuf[256] )
{
	//JPC̋
	sCam.Pos = VAdd( sCam.Pos, CharaVec);
	distance = sqrt( (Target.x - sCam.Pos.x) * (Target.x - sCam.Pos.x) + (Target.y - sCam.Pos.y) * (Target.y - sCam.Pos.y) + (Target.z - sCam.Pos.z) * (Target.z - sCam.Pos.z) );

	if( KeyBuf[KEY_INPUT_UP] == 1 ) distance -= 5.0f;
	if( distance < 30.0f ) distance = 30.0f;
	if( KeyBuf[KEY_INPUT_DOWN] == 1 ) distance += 5.0f;
	if( distance > 100.0f ) distance = 100.0f;
	if( sMouse.Subx > 0.0f ) sCam.y_r += PHI_F / 64;
	if( sMouse.Subx < 0.0f ) sCam.y_r -= PHI_F / 64;

	sCam.Pos.x = Target.x + distance * sin( sCam.y_r + sPC.y_r );
	sCam.Pos.y = Target.y;
	sCam.Pos.z = Target.z + distance * cos( sCam.y_r + sPC.y_r );

	//_Lɐݒ
	SetCameraPositionAndTarget_UpVecY( sCam.Pos, Target );
	//SetLightPositionHandle( sMap.Handle[2], sCam.Pos );
}